<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Kode Projek</label>

            <b-form-select
              v-model="filter.code"
              :options="formattedProjectOptions"
              size="lg"
              @change="setNickname($event)"
            ></b-form-select>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nama Proyek</label>

            <b-form-input
              v-model="filter.nickname"
              disabled
              size="lg"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Tipe</label>

            <b-form-select 
              v-model="filter.type" 
              :options="options.types" 
              size="lg"
            ></b-form-select>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Scope</label>

            <b-form-select
              v-model="filter.scope"
              :options="formattedScopeOptions"
              size="lg"
            ></b-form-select>
          </div>
        </div>

        <div class="d-flex justify-content-end mt-5">
          <div class="d-flex">
            <button class="btn btn-primary btn-md mr-2" @click="getReports(0)">
              Tampilkan Seluruhnya
            </button>

            <button class="btn btn-secondary btn-md" @click="getReports(1)">
              Tampilkan Latest
            </button>
          </div>
        </div>
      </div>
    </div>

    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row mb-5">
          <div class="col-md-4 offset-md-8 py-2 col-sm-12">
            <div class="input-group">
              <div class="input-group-prepend">
                <span class="input-group-text">
                  <i class="flaticon2-search-1"></i>
                </span>
              </div>

              <input type="text" class="form-control" placeholder="Search" />
            </div>
          </div>
        </div>

        <complete-table :loading="loading" :data="deliverableDesigns">
          <template #header>
            <tr class="text-left">
              <th style="min-width: 200px" class="pl-7">
                <span class="text-dark-75">Numbering</span>
              </th>
              <th style="min-width: 150px">Title</th>
              <th style="min-width: 150px">Stasiun</th>
              <th style="min-width: 150px">Scope</th>
              <th style="min-width: 150px">Type</th>
              <th style="min-width: 150px">Date</th>
              <th style="min-width: 150px">Status</th>
              <th style="min-width: 150px">Revision</th>
              <th style="min-width: 150px">Version</th>
              <th style="min-width: 150px">Plan Date</th>
              <th style="min-width: 150px">Delay</th>
              <th style="min-width: 150px">Logistic</th>
              <th style="min-width: 150px">SHD External</th>
              <th style="min-width: 150px">Asbuilt</th>
              <th style="min-width: 200px">Change Management</th>
            </tr>
          </template>

          <template #defaultBody="{ item: deliverableDesign, i }">
            <tr v-bind:key="i" class="border-0">
              <td class="pl-0 pt-8">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ deliverableDesign.numbering }}
                </span>
              </td>

              <td class="pl-0 pt-8">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ deliverableDesign.title }}
                </span>
              </td>

              <td class="pl-0 pt-8">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{
                    deliverableDesign.station
                      ? deliverableDesign.station.name
                      : "-"
                  }}
                </span>
              </td>

              <td class="pl-0 pt-8">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{
                    deliverableDesign.scope
                      ? deliverableDesign.scope.name
                      : "-"
                  }}
                </span>
              </td>

              <td class="pl-0 pt-8">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{
                    deliverableDesign.type ? deliverableDesign.type.name : "-"
                  }}
                </span>
              </td>

              <td class="pl-0 pt-8">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ deliverableDesign.date }}
                </span>
              </td>

              <td class="pl-0 pt-8">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ deliverableDesign.status }}
                </span>
              </td>

              <td class="pl-0 pt-8">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ deliverableDesign.revision_version }}
                </span>
              </td>

              <td class="pl-0 pt-8">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ deliverableDesign.version }}
                </span>
              </td>

              <td class="pl-0 pt-8">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ deliverableDesign.planning_date }}
                </span>
              </td>

              <td class="pl-0 pt-8">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ deliverableDesign.delay }}
                </span>
              </td>

              <td class="pl-0 pt-8">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{
                    deliverableDesign.monitoring_logistic_status
                      ? "Ya"
                      : "Tidak"
                  }}
                </span>
              </td>

              <td class="pl-0 pt-8">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{
                    deliverableDesign.monitoring_shd_external_status
                      ? "Ya"
                      : "Tidak"
                  }}
                </span>
              </td>

              <td class="pl-0 pt-8">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ deliverableDesign.asbuilt_drawing_numbering }}
                </span>
              </td>

              <td class="pl-0 pt-8">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{
                    deliverableDesign.monitoring_change_management_status
                      ? "Yes"
                      : "No"
                  }}
                </span>
              </td>
            </tr>
          </template>
        </complete-table>
      </div>
    </div>
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "../../../core/services/store/breadcrumbs.module";
import CompleteTable from "../../content/widgets/advance-table/CompleteTable";
import { mapState } from "vuex";
import { arrayMoreThanOne } from "../../../core/helper/array-validation.helper";
import { GET_PROJECT_DETAIL } from "../../../core/services/store/project.module";
import { GET_SCOPES } from "../../../core/services/store/scope.module";
import { GET_DELIVERABLE_DESIGN } from "../../../core/services/store/reporting-deliverable-design.module";
import { showToast } from "../../../core/helper/toast.helper";

export default {
  components: { CompleteTable },
  data() {
    return {
      filter: {
        code: null,
        nickname: null,
        scope: null,
        type: null
      },
      options: {
        types: [
          {
            value: null,
            text: "Pilih tipe"
          },
          {
            value: "doc",
            text: "DOC"
          },
          {
            value: "form",
            text: "FORM"
          },
          {
            value: "draw",
            text: "DRAW"
          },
        ]
      }
    };
  },
  computed: {
    ...mapState({
      projects: state => state.projectDetails.projectDetails?.data,
      scopes: state => state.scope.scopes?.data,
      deliverableDesigns: state =>
        state.deliverableDesign.deliverableDesigns?.data,
      loading: state => state.deliverableDesign.loading
    }),

    formattedProjectOptions() {
      let projects = [];

      if (arrayMoreThanOne(this.projects)) {
        projects = this.projects.map(project => {
          return {
            value: project.code,
            text: project.code
          };
        });
      }

      return [{ value: null, text: "Pilih Nickname" }, ...projects];
    },

    formattedScopeOptions() {
      let scopes = [];

      if (arrayMoreThanOne(this.scopes)) {
        scopes = this.scopes.map(scope => {
          return {
            value: scope.code,
            text: scope.name
          };
        });
      }

      return [{ value: null, text: "Pilih Scope" }, ...scopes];
    }
  },
  methods: {
    getProjects() {
      if (!arrayMoreThanOne(this.projects)) {
        this.$store.dispatch(GET_PROJECT_DETAIL, { jobdesk: "design" });
      }
    },

    getScopes() {
      if (!arrayMoreThanOne(this.scopes)) {
        this.$store.dispatch(GET_SCOPES, {});
      }
    },

    getReports(latest) {
      if (this.filter.code) {
        this.$store.dispatch(GET_DELIVERABLE_DESIGN, {
          params: {
            ...this.filter
          },
          code: this.filter?.code,
          latest
        });
      } else {
        showToast("Gagal", "Pilih projek terlebih dahulu", "danger");
      }
    },

    setNickname(value) {
      const project = this.projects?.find(project => project?.code === value);

      this.filter.nickname = project?.nickname;
    }
  },
  mounted() {
    this.$store.dispatch(SET_BREADCRUMB, [
      { title: "Report seDeliverable Design" }
    ]);

    this.getProjects();

    this.getScopes();
  }
};
</script>
